"""\
Request body (POST input) service
"""

import cgi
import StringIO
import logging

log = logging.getLogger(__name__)

class HTTPInputService(object):

    @staticmethod
    def create(flow, name, config=None):
        return HTTPInputService()

    @staticmethod
    def config(flow, name):
        # There is no configuration
        return None

    def start(self, flow, name):
        # We expect this to be a composite name
        base, name = name.split('.')
        if not flow.has_key(base):
            raise Exception(
                'Expected the HTTP service to be present as flow.%s'%base
            )
        if flow.http.environ.get('wsgi.input') and \
           flow.http.environ.get('REQUEST_METHOD', '').upper() == "POST":
            log.debug('Parsing the request body')
            s = StringIO.StringIO()
            try:
                request_body_len = int(flow.http.environ['CONTENT_LENGTH'])
                input = flow.http.environ['wsgi.input'].read(request_body_len)
            except (TypeError, ValueError):
                raise Exception('Invalid HTTP post, no valid CONTENT_LENGTH')
            s.write(input)
            s.seek(0)
            flow[base][name] = cgi.FieldStorage(
                fp=s, 
                environ=flow.http.environ, 
                keep_blank_values=True
            )
            s.seek(0)
            flow.http.environ['wsgi.input'] = s
        else:
            log.debug('Not parsing the request body')
            flow[base][name] = None


