"""\
Query string service
"""

import cgi
import logging

log = logging.getLogger(__name__)

class HTTPQueryService(object):

    @staticmethod
    def create(flow, name, config=None):
        return HTTPQueryService()

    @staticmethod
    def config(flow, name):
        # There is no configuration
        return None

    def start(self, flow, name):
        # We expect this to be a composite name
        base, name = name.split('.')
        if not flow.has_key(base):
            raise Exception(
                'Expected the HTTP service to be present as flow.%s'%base
            )
        if flow.http.environ.get('QUERY_STRING') \
           and flow.http.environ.get('REQUEST_METHOD', '').upper() == "GET":
            flow[base][name] = cgi.FieldStorage(
                environ=flow.http.environ, 
                keep_blank_values=True
            )
        else:
            flow[base][name] = None

